Work Breakdown Structure (WBS) in EJ2 JavaScript Gantt Component

6 Aug 202516 minutes to read

The Work Breakdown Structure (WBS) organizes project tasks hierarchically in the Gantt component by assigning unique codes to each task. This system enhances visualization and management by clearly reflecting task relationships and levels. It is especially useful in complex environments like construction projects or enterprise-scale software development.


Configuration and implementation

  • Enable WBS Codes: Set the enableWBS property to true to automatically generate unique task codes and their predecessors.
  • Auto-Update Codes: Set the enableAutoWbsUpdate property to true to maintain WBS code accuracy during operations like sorting, filtering, editing, or drag-and-drop.
ej.gantt.Gantt.Inject(ej.gantt.Selection,
    ej.gantt.Toolbar,
    ej.gantt.DayMarkers,
    ej.gantt.Edit,
    ej.gantt.Filter,
    ej.gantt.Sort,
    ej.gantt.ContextMenu);
var ganttChart = new ej.gantt.Gantt({
    dataSource: WBSData,
    allowSorting: true,
    enableContextMenu: true,
    enableWBS: true,
    enableAutoWbsUpdate: true,
    taskFields: {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        dependency: 'Predecessor',
        parentID: 'ParentId'
    },
    treeColumnIndex: 2,
    editSettings: {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true,
        allowTaskbarEditing: true,
        showDeleteConfirmDialog: true
    },
    columns: [
        { field: 'TaskID', headerText: 'Task ID', visible: false },
        { field: 'WBSCode', headerText: 'WBS Code', width: '150px' },
        { field: 'TaskName', headerText: 'Task Name', allowReordering: false, width: '260px' },
        { field: 'StartDate', headerText: 'Start Date', width: '140px' },
        { field: 'WBSPredecessor', headerText: 'WBS Predecessor', width: '190px' },
        { field: 'Duration', headerText: 'Duration', allowEditing: false, width: '130px' },
        { field: 'Progress', headerText: 'Progress' },
    ],
    eventMarkers: [
        {
            day: new Date('04/2/2024'),
            label: 'Project Initiation'
        }
    ],
    toolbar: ['Add', 'Edit', 'Update', 'Delete', 'Cancel', 'ExpandAll', 'CollapseAll'],
    allowPdfExport: true,
    allowSelection: true,
    splitterSettings: {
        columnIndex: 4,
    },
    selectionSettings: {
        mode: 'Row',
        type: 'Single',
        enableToggle: false
    },
    tooltipSettings: {
        showTooltip: true
    },
    filterSettings: {
        type: 'Menu'
    },
    allowFiltering: true,
    gridLines: "Both",
    highlightWeekends: true,
    timelineSettings: {
        showTooltip: true,
        topTier: {
            unit: 'Week',
            format: 'dd/MM/yyyy'
        },
        bottomTier: {
            unit: 'Day',
            count: 1
        }
    },
    labelSettings: {
        taskLabel: '${Progress}%'
    },
    taskbarHeight: 20,
    rowHeight: 40,
    height: '550px',
    allowUnscheduledTasks: true,
    projectStartDate: new Date('03/31/2024'),
    projectEndDate: new Date('05/30/2024'),
});
ganttChart.appendTo('#Gantt');
<!DOCTYPE html>
<html lang="en">
    <head>
        <title>EJ2 Gantt</title>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <meta name="description" content="Typescript Gantt Controls">
        <meta name="author" content="Syncfusion">
        <link href="index.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/32.1.19/material.css" rel="stylesheet" type="text/css">   
        <script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
        <script src="es5-datasource.js" type="text/javascript"></script>
    <script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

    <body>
        <div id="container">
            <div id="Gantt"></div>
        </div>
        <script>
            var ele = document.getElementById('container');
            if(ele) {
            ele.style.visibility = "visible";
            }   
        </script>
        <script src="index.js" type="text/javascript"></script>
    </body>
</html>


Managing WBS code updates

For better performance, you can control when WBS codes are updated by using the actionBegin and dataBound events. This is particularly useful during actions like dragging and dropping rows.

In the following example, WBS auto-update is enabled only during the row drag and drop action using these events.

ej.gantt.Gantt.Inject(ej.gantt.Selection,
    ej.gantt.Toolbar,
    ej.gantt.DayMarkers,
    ej.gantt.Edit,
    ej.gantt.Filter,
    ej.gantt.Sort,
    ej.gantt.ContextMenu);


var isRowDropped = false;
var ganttChart = new ej.gantt.Gantt({
    dataSource: WBSData,
    allowSorting: true,
    enableContextMenu: true,
    enableWBS: true,
    dataBound: function () {
        if (isRowDropped) {
            ganttChart.enableAutoWbsUpdate = false;
            isRowDropped = false;
        }
    },
    actionBegin: function (args) {
        if (args.requestType === "beforeDrop") {
            isRowDropped = true;
            ganttChart.enableAutoWbsUpdate = false;
        }
    },
    enableAutoWbsUpdate: false,
    taskFields: {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        dependency: 'Predecessor',
        parentID: 'ParentId'
    },
    treeColumnIndex: 2,
    editSettings: {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true,
        allowTaskbarEditing: true,
        showDeleteConfirmDialog: true
    },
    columns: [
        { field: 'TaskID', headerText: 'Task ID', visible: false },
        { field: 'WBSCode', headerText: 'WBS Code', width: '150px' },
        { field: 'TaskName', headerText: 'Task Name', allowReordering: false, width: '260px' },
        { field: 'StartDate', headerText: 'Start Date', width: '140px' },
        { field: 'WBSPredecessor', headerText: 'WBS Predecessor', width: '190px' },
        { field: 'Duration', headerText: 'Duration', allowEditing: false, width: '130px' },
        { field: 'Progress', headerText: 'Progress' },
    ],
    eventMarkers: [
        {
            day: new Date('04/2/2024'),
            label: 'Project Initiation'
        }
    ],
    toolbar: ['Add', 'Edit', 'Update', 'Delete', 'Cancel', 'ExpandAll', 'CollapseAll'],
    allowPdfExport: true,
    allowSelection: true,
    splitterSettings: {
        columnIndex: 4,
    },
    selectionSettings: {
        mode: 'Row',
        type: 'Single',
        enableToggle: false
    },
    tooltipSettings: {
        showTooltip: true
    },
    filterSettings: {
        type: 'Menu'
    },
    allowFiltering: true,
    gridLines: "Both",
    highlightWeekends: true,
    timelineSettings: {
        showTooltip: true,
        topTier: {
            unit: 'Week',
            format: 'dd/MM/yyyy'
        },
        bottomTier: {
            unit: 'Day',
            count: 1
        }
    },
    labelSettings: {
        taskLabel: '${Progress}%'
    },
    taskbarHeight: 20,
    rowHeight: 40,
    height: '550px',
    allowUnscheduledTasks: true,
    projectStartDate: new Date('03/31/2024'),
    projectEndDate: new Date('05/30/2024'),
});
ganttChart.appendTo('#Gantt');
<!DOCTYPE html><html lang="en"><head>
     <title>EJ2 Gantt</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript Gantt Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
	<link href="https://cdn.syncfusion.com/ej2/32.1.19/material.css" rel="stylesheet" type="text/css">
    
    
<script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
       
     
    <div id="container">
        <div id="Gantt"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Limitations

The WBS feature has a few limitations in the Gantt component:

  • Editing of the WBS code and WBS predecessor columns is not supported.
  • Load on demand is not supported with the WBS feature.
  • WBS Code and WBS Predecessor fields cannot be mapped directly from the data source.

HelpBot Assistant

How can I help you?

Work Breakdown Structure (WBS) in Angular Gantt Chart Component

1 Feb 202617 minutes to read

The Work Breakdown Structure (WBS) organizes project tasks hierarchically by assigning unique codes to each task. This improves task visibility and management, especially in large-scale construction or enterprise-level software projects.

Configuration and implementation

To enable WBS in the Gantt Chart component:

  • Enable WBS Codes: Set enableWBS to true to automatically generate unique task codes and define their predecessors.
  • Auto-Update Codes: Set enableAutoWbsUpdate to true to maintain accurate WBS codes during operations such as sorting, editing, or drag-and-drop.
import { GanttAllModule } from '@syncfusion/ej2-angular-gantt';
import { Component, ViewEncapsulation, OnInit } from '@angular/core';
import { WBSData } from './data';

@Component({
    imports: [ GanttAllModule],
    standalone: true,
    selector: 'app-root',
    template:
    `<ejs-gantt id="ganttWbs" #gantt height="450px" [dataSource]="data" [taskFields]="taskSettings" [columns]="columns"
      [timelineSettings]="timelineSettings" [labelSettings]="labelSettings" [editSettings]="editSettings"
      [allowFiltering]="true" [allowSorting]="true" [toolbar]="toolbar" [treeColumnIndex]="2"
      [filterSettings]="filterSettings" [allowSelection]="true" [projectStartDate]="projectStartDate"
      [projectEndDate]="projectEndDate" [enableWBS]="true" [enableAutoWbsUpdate]="true"
      [splitterSettings]="splitterSettings" [rowHeight]="rowHeight" [taskbarHeight]="taskbarHeight"
      [allowUnscheduledTasks]="allowUnscheduledTasks" [eventMarkers]="eventMarkers">
    </ejs-gantt>`,
    encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
    public data?: object[];
    public taskSettings?: object;
    public columns?: object[];
    public toolbar?: string[];
    public editSettings?: object;
    public splitterSettings?: object;
    public selectionSettings?: object;
    public tooltipSettings?: object;
    public filterSettings?: object;
    public timelineSettings?: object;
    public labelSettings?: object;
    public height?: string;
    public taskbarHeight?: number;
    public rowHeight?: number;
    public allowUnscheduledTasks?: boolean;
    public enableWBS?: boolean;
    public enableAutoWbsUpdate?: boolean;
    public projectStartDate?: Date;
    public projectEndDate?: Date;
    public eventMarkers?: object[];

    public ngOnInit(): void {
        this.data = WBSData;
        this.taskSettings = {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            duration: 'Duration',
            progress: 'Progress',
            dependency: 'Predecessor',
            parentID: 'ParentId'
        };
        this.columns = [
            { field: 'TaskID', headerText: 'Task ID', visible: false },
            { field: 'WBSCode', headerText: 'WBS Code', width: '150px' },
            { field: 'TaskName', headerText: 'Task Name', allowReordering: false, width: '260px' },
            { field: 'StartDate', headerText: 'Start Date', width: '140px' },
            { field: 'WBSPredecessor', headerText: 'WBS Predecessor', width: '190px' },
            { field: 'Duration', headerText: 'Duration', allowEditing: false, width: '130px' },
            { field: 'Progress', headerText: 'Progress' },
        ];
        this.eventMarkers = [
            {
                day: new Date('04/2/2024'),
                label: 'Project Initiation'
            }
        ];
        this.editSettings = {
            allowAdding: true,
            allowEditing: true,
            allowDeleting: true,
            allowTaskbarEditing: true,
            showDeleteConfirmDialog: true
        };
        this.toolbar = ['Add', 'Edit', 'Update', 'Delete', 'Cancel', 'ExpandAll', 'CollapseAll'];
        this.splitterSettings = { columnIndex: 4 };
        this.selectionSettings = { mode: 'Row', type: 'Single', enableToggle: false };
        this.tooltipSettings = { showTooltip: true };
        this.filterSettings = { type: 'Menu' };
        this.timelineSettings = {
            showTooltip: true,
            topTier: { unit: 'Week', format: 'dd/MM/yyyy' },
            bottomTier: { unit: 'Day', count: 1 }
        };
        this.labelSettings = {
            taskLabel: '${Progress}%'
        };
        this.taskbarHeight = 20;
        this.rowHeight = 40;
        this.height = '550px';
        this.allowUnscheduledTasks = true;
        this.enableWBS = true;
        this.enableAutoWbsUpdate = true;
        this.projectStartDate = new Date('03/31/2024');
        this.projectEndDate = new Date('05/30/2024');
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Managing WBS code updates

To optimize performance, WBS code updates can be controlled using the actionBegin and dataBound events. This is especially useful during operations like row drag-and-drop, where auto-update is triggered only during that specific action to ensure efficient and accurate code handling.

In the following example, WBS auto-update is enabled only during the row drag and drop action using these events.

import { GanttAllModule } from '@syncfusion/ej2-angular-gantt';
import { Component, ViewEncapsulation, ViewChild, OnInit } from '@angular/core';
import { GanttComponent } from '@syncfusion/ej2-angular-gantt';
import { WBSData } from './data';

@Component({
    imports: [GanttAllModule],
    standalone: true,
    selector: 'app-root',
    template:
        `<ejs-gantt id="ganttWbs" #gantt height="450px" [dataSource]="data" [taskFields]="taskSettings" [columns]="columns"
      [timelineSettings]="timelineSettings" [labelSettings]="labelSettings" [editSettings]="editSettings"
      [allowFiltering]="true" [allowSorting]="true" [toolbar]="toolbar" [treeColumnIndex]="2"
      [filterSettings]="filterSettings" [allowSelection]="true" [projectStartDate]="projectStartDate"
      [projectEndDate]="projectEndDate" [enableWBS]="true" [enableAutoWbsUpdate]="false"
      [splitterSettings]="splitterSettings" [rowHeight]="rowHeight" [taskbarHeight]="taskbarHeight"
      [allowUnscheduledTasks]="allowUnscheduledTasks" [eventMarkers]="eventMarkers" [allowRowDragAndDrop]="true" (dataBound)="dataBound()" (actionBegin)="actionBegin($event)">
    </ejs-gantt>`,
    encapsulation: ViewEncapsulation.None
})

export class AppComponent implements OnInit {
    @ViewChild('gantt') public ganttInstance?: GanttComponent;
    public isRowDropped: boolean = false;
    public data?: object[];
    public taskSettings?: object;
    public columns?: object[];
    public toolbar?: string[];
    public editSettings?: object;
    public splitterSettings?: object;
    public selectionSettings?: object;
    public tooltipSettings?: object;
    public filterSettings?: object;
    public timelineSettings?: object;
    public labelSettings?: object;
    public height?: string;
    public taskbarHeight?: number;
    public rowHeight?: number;
    public allowUnscheduledTasks?: boolean;
    public enableWBS?: boolean;
    public enableAutoWbsUpdate?: boolean;
    public projectStartDate?: Date;
    public projectEndDate?: Date;
    public eventMarkers?: object[];

    public ngOnInit(): void {
        this.data = WBSData;
        this.taskSettings = {
            id: 'TaskID',
            name: 'TaskName',
            startDate: 'StartDate',
            duration: 'Duration',
            progress: 'Progress',
            dependency: 'Predecessor',
            parentID: 'ParentId'
        };
        this.columns = [
            { field: 'TaskID', headerText: 'Task ID', visible: false },
            { field: 'WBSCode', headerText: 'WBS Code', width: '150px' },
            { field: 'TaskName', headerText: 'Task Name', allowReordering: false, width: '260px' },
            { field: 'StartDate', headerText: 'Start Date', width: '140px' },
            { field: 'WBSPredecessor', headerText: 'WBS Predecessor', width: '190px' },
            { field: 'Duration', headerText: 'Duration', allowEditing: false, width: '130px' },
            { field: 'Progress', headerText: 'Progress' },
        ];
        this.eventMarkers = [
            {
                day: new Date('04/2/2024'),
                label: 'Project Initiation'
            }
        ];
        this.editSettings = {
            allowAdding: true,
            allowEditing: true,
            allowDeleting: true,
            allowTaskbarEditing: true,
            showDeleteConfirmDialog: true
        };
        this.toolbar = ['Add', 'Edit', 'Update', 'Delete', 'Cancel', 'ExpandAll', 'CollapseAll'];
        this.splitterSettings = { columnIndex: 4 };
        this.selectionSettings = { mode: 'Row', type: 'Single', enableToggle: false };
        this.tooltipSettings = { showTooltip: true };
        this.filterSettings = { type: 'Menu' };
        this.timelineSettings = {
            showTooltip: true,
            topTier: { unit: 'Week', format: 'dd/MM/yyyy' },
            bottomTier: { unit: 'Day', count: 1 }
        };
        this.labelSettings = {
            taskLabel: '${Progress}%'
        };
        this.taskbarHeight = 20;
        this.rowHeight = 40;
        this.height = '550px';
        this.allowUnscheduledTasks = true;
        this.enableWBS = true;
        this.enableAutoWbsUpdate = true;
        this.projectStartDate = new Date('03/31/2024');
        this.projectEndDate = new Date('05/30/2024');
    }

    public dataBound(): void {
        if (this.isRowDropped) {
            (this.ganttInstance as GanttComponent).enableAutoWbsUpdate = false;
            this.isRowDropped = false;
        }
    }

    public actionBegin(args: any): void {
        if (args.requestType === "beforeDrop") {
            this.isRowDropped = true;
            (this.ganttInstance as GanttComponent).enableAutoWbsUpdate = true;
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Limitations

The WBS feature has a few limitations in the Gantt Chart component:

  • Editing of the WBS code and WBS predecessor columns is not supported.
  • Load on demand is not supported with the WBS feature.
  • WBS Code and WBS Predecessor fields cannot be mapped directly from the data source.

Work Breakdown Structure (WBS) in React Gantt Chart

31 Jan 202624 minutes to read

The Work Breakdown Structure (WBS) organizes project tasks hierarchically by assigning unique codes to each task. This improves task visibility and management, especially in large-scale construction or enterprise-level software projects.

Configuration and implementation

To enable WBS in the Gantt Chart component:

  • Enable WBS Codes: Set enableWBS to true to automatically generate unique task codes and define their predecessors.
  • Auto-Update Codes: Set enableAutoWbsUpdate to true to maintain accurate WBS codes during operations such as sorting, editing, or drag-and-drop.
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Selection, ColumnsDirective, ColumnDirective, Toolbar, DayMarkers, Edit, Filter, Sort, ContextMenu, EventMarkersDirective, EventMarkerDirective } from '@syncfusion/ej2-react-gantt';
import { WBSData } from './datasource';
function App() {
    const taskFields = {
        id: "TaskID",
        name: "TaskName",
        startDate: "StartDate",
        endDate: "EndDate",
        duration: "Duration",
        progress: "Progress",
        dependency: "Predecessor",
        parentID: 'ParentID'
    };

    let ganttInstance;
    const eventMarkerDay1 = new Date('04/02/2024');
    const editSettings = {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true,
        allowTaskbarEditing: true,
        showDeleteConfirmDialog: true,
    };

    const toolbar = ["Add", "Edit", "Update", "Delete", "Cancel", "ExpandAll", "CollapseAll"];

    const timelineSettings = {
        showTooltip: true,
        topTier: {
            unit: "Week",
            format: "dd/MM/yyyy",
        },
        bottomTier: {
            unit: "Day",
            count: 1,
        },
    };

    const labelSettings = {
        taskLabel: '${Progress}%'
    };

    const projectStartDate = new Date("03/31/2024");
    const projectEndDate = new Date("05/30/2024");

    const splitterSettings = {
        columnIndex: 4
    };

    const selectionSettings = {
        mode: "Row",
        type: "Single",
        enableToggle: false,
    };

    const tooltipSettings = {
        showTooltip: true,
    };

    const filterSettings = {
        type: "Menu",
    };

    return <GanttComponent id="EnableWbs" taskFields={taskFields} ref={ganttInstance} toolbar={toolbar} treeColumnIndex={2} dataSource={WBSData} allowSorting={true} enableContextMenu={true} enableWBS={true} enableAutoWbsUpdate={true} editSettings={editSettings} allowSelection={true} allowPdfExport={true} splitterSettings={splitterSettings} selectionSettings={selectionSettings} tooltipSettings={tooltipSettings} filterSettings={filterSettings} timelineSettings={timelineSettings} highlightWeekends={true} allowFiltering={true} gridLines={"Both"} labelSettings={labelSettings} taskbarHeight={20} rowHeight={40} height={"550px"} allowUnscheduledTasks={true} projectStartDate={projectStartDate} projectEndDate={projectEndDate}>
        <ColumnsDirective>
            <ColumnDirective field="TaskID" visible={false} />
            <ColumnDirective field="WBSCode" width='150px' />
            <ColumnDirective field="TaskName" headerText="Task Name" allowReordering={false} width='260px' />
            <ColumnDirective field="StartDate" headerText="Start Date" width='140px' />
            <ColumnDirective field="WBSPredecessor" headerText="WBS Predecessor" width='190px' />
            <ColumnDirective field="Duration" headerText="Duration" allowEditing={false} width='130px' />
            <ColumnDirective field="Progress" headerText="Progress" />
        </ColumnsDirective>
        <EventMarkersDirective>
            <EventMarkerDirective day={eventMarkerDay1} label='Project Initiation'></EventMarkerDirective>
        </EventMarkersDirective>
        <Inject services={[Selection, DayMarkers, Toolbar, Edit, Filter, Sort, ContextMenu]} />
    </GanttComponent>
};
ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { GanttComponent, Inject, Selection, ColumnsDirective, ColumnDirective, Toolbar, DayMarkers, Edit, Filter, Sort, ContextMenu, EventMarkersDirective, EventMarkerDirective } from '@syncfusion/ej2-react-gantt';
import { WBSData } from './datasource';
function App() {
    const taskFields = {
        id: "TaskID",
        name: "TaskName",
        startDate: "StartDate",
        endDate: "EndDate",
        duration: "Duration",
        progress: "Progress",
        dependency: "Predecessor",
        parentID: 'ParentID'
    };

    let ganttInstance;
    const eventMarkerDay1 = new Date('04/02/2024');
    const editSettings = {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true,
        allowTaskbarEditing: true,
        showDeleteConfirmDialog: true,
    };

    const toolbar = ["Add", "Edit", "Update", "Delete", "Cancel", "ExpandAll", "CollapseAll"];

    const timelineSettings = {
        showTooltip: true,
        topTier: {
            unit: "Week",
            format: "dd/MM/yyyy",
        },
        bottomTier: {
            unit: "Day",
            count: 1,
        },
    };

    const labelSettings = {
        taskLabel: '${Progress}%'
    };

    const projectStartDate = new Date("03/31/2024");
    const projectEndDate = new Date("05/30/2024");

    const splitterSettings = {
        columnIndex: 4
    };

    const selectionSettings = {
        mode: "Row",
        type: "Single",
        enableToggle: false,
    };

    const tooltipSettings = {
        showTooltip: true,
    };

    const filterSettings = {
        type: "Menu",
    };

    return <GanttComponent id="EnableWbs" taskFields={taskFields} ref={ganttInstance} toolbar={toolbar} treeColumnIndex={2} dataSource={WBSData} allowSorting={true} enableContextMenu={true} enableWBS={true} enableAutoWbsUpdate={true} editSettings={editSettings} allowSelection={true} allowPdfExport={true} splitterSettings={splitterSettings} selectionSettings={selectionSettings} tooltipSettings={tooltipSettings} filterSettings={filterSettings} timelineSettings={timelineSettings} highlightWeekends={true} allowFiltering={true} gridLines={"Both"} labelSettings={labelSettings} taskbarHeight={20} rowHeight={40} height={"550px"} allowUnscheduledTasks={true} projectStartDate={projectStartDate} projectEndDate={projectEndDate}>
        <ColumnsDirective>
            <ColumnDirective field="TaskID" visible={false} />
            <ColumnDirective field="WBSCode" width='150px' />
            <ColumnDirective field="TaskName" headerText="Task Name" allowReordering={false} width='260px' />
            <ColumnDirective field="StartDate" headerText="Start Date" width='140px' />
            <ColumnDirective field="WBSPredecessor" headerText="WBS Predecessor" width='190px' />
            <ColumnDirective field="Duration" headerText="Duration" allowEditing={false} width='130px' />
            <ColumnDirective field="Progress" headerText="Progress" />
        </ColumnsDirective>
        <EventMarkersDirective>
            <EventMarkerDirective day={eventMarkerDay1} label='Project Initiation'></EventMarkerDirective>
        </EventMarkersDirective>
        <Inject services={[Selection, DayMarkers, Toolbar, Edit, Filter, Sort, ContextMenu]} />
    </GanttComponent>
};
ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='root'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Managing WBS code updates

To optimize performance, WBS code updates can be controlled using the actionBegin and dataBound events. This is especially useful during operations like row drag-and-drop, where auto-update is triggered only during that specific action to ensure efficient and accurate code handling.

In the following example, WBS auto-update is enabled only during the row drag and drop action using these events.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
    GanttComponent,
    Inject,
    Selection,
    ColumnsDirective,
    ColumnDirective,
    Toolbar,
    DayMarkers,
    Edit,
    Filter,
    Sort,
    ContextMenu,
    EventMarkersDirective,
    EventMarkerDirective,
    RowDD
} from '@syncfusion/ej2-react-gantt';
import { WBSData } from './datasource';

function App() {
    let ganttInstance;
    let isRowDropped = false;

    const taskFields = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        endDate: 'EndDate',
        duration: 'Duration',
        progress: 'Progress',
        dependency: 'Predecessor',
        parentID: 'ParentID'
    };

    const eventMarkerDay1 = new Date('04/02/2024');

    const editSettings = {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true,
        allowTaskbarEditing: true,
        showDeleteConfirmDialog: true
    };

    const toolbar = ['Add', 'Edit', 'Update', 'Delete', 'Cancel', 'ExpandAll', 'CollapseAll'];

    const timelineSettings = {
        showTooltip: true,
        topTier: { unit: 'Week', format: 'dd/MM/yyyy' },
        bottomTier: { unit: 'Day', count: 1 }
    };

    const labelSettings = { taskLabel: '${Progress}%' };

    const projectStartDate = new Date('03/31/2024');
    const projectEndDate = new Date('05/30/2024');

    const splitterSettings = { columnIndex: 4 };
    const selectionSettings = { mode: 'Row', type: 'Single', enableToggle: false };
    const tooltipSettings = { showTooltip: true };
    const filterSettings = { type: 'Menu' };

    const dataBound = () => {
        if (isRowDropped && ganttInstance) {
            ganttInstance.enableAutoWbsUpdate = false;
            isRowDropped = false;
        }
    };

    const actionBegin = (args) => {
        if (args.requestType === 'beforeDrop' && ganttInstance) {
            isRowDropped = true;
            ganttInstance.enableAutoWbsUpdate = true;
        }
    };

    return (
        <GanttComponent
            id="EnableWbs"
            ref={(gantt) => (ganttInstance = gantt)}
            taskFields={taskFields}
            toolbar={toolbar}
            treeColumnIndex={2}
            dataSource={WBSData}
            allowSorting={true}
            enableContextMenu={true}
            enableWBS={true}
            enableAutoWbsUpdate={true}
            editSettings={editSettings}
            allowSelection={true}
            allowPdfExport={true}
            splitterSettings={splitterSettings}
            selectionSettings={selectionSettings}
            tooltipSettings={tooltipSettings}
            filterSettings={filterSettings}
            timelineSettings={timelineSettings}
            highlightWeekends={true}
            allowFiltering={true}
            gridLines="Both"
            labelSettings={labelSettings}
            taskbarHeight={20}
            rowHeight={40}
            height="550px"
            allowUnscheduledTasks={true}
            projectStartDate={projectStartDate}
            projectEndDate={projectEndDate}
            allowRowDragAndDrop={true}
            dataBound={dataBound}
            actionBegin={actionBegin}
        >
            <ColumnsDirective>
                <ColumnDirective field="TaskID" visible={false} />
                <ColumnDirective field="WBSCode" width="150px" />
                <ColumnDirective field="TaskName" headerText="Task Name" allowReordering={false} width="260px" />
                <ColumnDirective field="StartDate" headerText="Start Date" width="140px" />
                <ColumnDirective field="WBSPredecessor" headerText="WBS Predecessor" width="190px" />
                <ColumnDirective field="Duration" headerText="Duration" allowEditing={false} width="130px" />
                <ColumnDirective field="Progress" headerText="Progress" />
            </ColumnsDirective>
            <EventMarkersDirective>
                <EventMarkerDirective day={eventMarkerDay1} label="Project Initiation" />
            </EventMarkersDirective>
            <Inject services={[Selection, DayMarkers, Toolbar, Edit, Filter, Sort, ContextMenu, RowDD]} />
        </GanttComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
    GanttComponent,
    Inject,
    Selection,
    ColumnsDirective,
    ColumnDirective,
    Toolbar,
    DayMarkers,
    Edit,
    Filter,
    Sort,
    ContextMenu,
    EventMarkersDirective,
    EventMarkerDirective,
    actionBeginEventArgs,
    RowDD
} from '@syncfusion/ej2-react-gantt';
import { WBSData } from './datasource';

function App() {
    let ganttInstance: GanttComponent;
    let isRowDropped = false;

    const taskFields = {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        endDate: 'EndDate',
        duration: 'Duration',
        progress: 'Progress',
        dependency: 'Predecessor',
        parentID: 'ParentID'
    };

    const eventMarkerDay1 = new Date('04/02/2024');

    const editSettings = {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true,
        allowTaskbarEditing: true,
        showDeleteConfirmDialog: true
    };

    const toolbar = ['Add', 'Edit', 'Update', 'Delete', 'Cancel', 'ExpandAll', 'CollapseAll'];

    const timelineSettings = {
        showTooltip: true,
        topTier: { unit: 'Week', format: 'dd/MM/yyyy' },
        bottomTier: { unit: 'Day', count: 1 }
    };

    const labelSettings = { taskLabel: '${Progress}%' };

    const projectStartDate = new Date('03/31/2024');
    const projectEndDate = new Date('05/30/2024');

    const splitterSettings = { columnIndex: 4 };
    const selectionSettings = { mode: 'Row', type: 'Single', enableToggle: false };
    const tooltipSettings = { showTooltip: true };
    const filterSettings = { type: 'Menu' };

    const dataBound = () => {
        if (isRowDropped && ganttInstance) {
            ganttInstance.enableAutoWbsUpdate = false;
            isRowDropped = false;
        }
    };

    const actionBegin = (args: actionBeginEventArgs) => {
        if (args.requestType === 'beforeDrop' && ganttInstance) {
            isRowDropped = true;
            ganttInstance.enableAutoWbsUpdate = true;
        }
    };

    return (
        <GanttComponent
            id="EnableWbs"
            ref={(gantt) => (ganttInstance = gantt)}
            taskFields={taskFields}
            toolbar={toolbar}
            treeColumnIndex={2}
            dataSource={WBSData}
            allowSorting={true}
            enableContextMenu={true}
            enableWBS={true}
            enableAutoWbsUpdate={true}
            editSettings={editSettings}
            allowSelection={true}
            allowPdfExport={true}
            splitterSettings={splitterSettings}
            selectionSettings={selectionSettings}
            tooltipSettings={tooltipSettings}
            filterSettings={filterSettings}
            timelineSettings={timelineSettings}
            highlightWeekends={true}
            allowFiltering={true}
            gridLines="Both"
            labelSettings={labelSettings}
            taskbarHeight={20}
            rowHeight={40}
            height="550px"
            allowUnscheduledTasks={true}
            projectStartDate={projectStartDate}
            projectEndDate={projectEndDate}
            allowRowDragAndDrop={true}
            dataBound={dataBound}
            actionBegin={actionBegin}
        >
            <ColumnsDirective>
                <ColumnDirective field="TaskID" visible={false} />
                <ColumnDirective field="WBSCode" width="150px" />
                <ColumnDirective field="TaskName" headerText="Task Name" allowReordering={false} width="260px" />
                <ColumnDirective field="StartDate" headerText="Start Date" width="140px" />
                <ColumnDirective field="WBSPredecessor" headerText="WBS Predecessor" width="190px" />
                <ColumnDirective field="Duration" headerText="Duration" allowEditing={false} width="130px" />
                <ColumnDirective field="Progress" headerText="Progress" />
            </ColumnsDirective>
            <EventMarkersDirective>
                <EventMarkerDirective day={eventMarkerDay1} label="Project Initiation" />
            </EventMarkersDirective>
            <Inject services={[Selection, DayMarkers, Toolbar, Edit, Filter, Sort, ContextMenu, RowDD]} />
        </GanttComponent>
    );
}

ReactDOM.render(<App />, document.getElementById('root'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Gantt</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/tailwind3.css" rel="stylesheet" type="text/css" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
    <style>
        #loader {
            color: #008cff;
            height: 40px;
            left: 45%;
            position: absolute;
            top: 45%;
            width: 30%;
        }
    </style>
</head>

<body>
    <div id='root'>
        <div id='loader'>Loading....</div>
    </div>
</body>

</html>

Limitations

The WBS feature has a few limitations in the Gantt Chart component:

  • Editing of the WBS code and WBS predecessor columns is not supported.
  • Load on demand is not supported with the WBS feature.
  • WBS Code and WBS Predecessor fields cannot be mapped directly from the data source.

HelpBot Assistant

How can I help you?

Work Breakdown Structure (WBS) in Vue Gantt Chart Component

3 Feb 202622 minutes to read

The Work Breakdown Structure (WBS) organizes project tasks hierarchically in the Gantt Chart component by assigning unique codes to each task. This system enhances visualization and management by clearly reflecting task relationships and levels. It is especially useful in complex environments such as construction projects or enterprise-scale software development.

Configuration and implementation

To enable and configure WBS in your Gantt Chart component:

  • Enable WBS Codes: Set the enableWBS property to true to automatically generate unique task codes and their predecessors.
  • Auto-Update Codes: Set the enableAutoWbsUpdate property to true to maintain accurate WBS codes during actions like sorting, filtering, editing, or drag-and-drop.
<template>
  <div class="content-wrapper">
    <ejs-gantt
      ref="gantt"
      id="HierarchyProjectview"
      :dataSource="projectData"
      :taskFields="taskFields"
      :columns="columns"
      :editSettings="editSettings"
      :toolbar="toolbar"
      :allowSorting="true"
      :enableContextMenu="true"
      :enableWBS="enableWBS"
      :treeColumnIndex="2"
      :enableAutoWbsUpdate="enableAutoWbsUpdate"
      :allowFiltering="true"
      :filterSettings="filterSettings"
      :selectionSettings="selectionSettings"
      :splitterSettings="splitterSettings"
      :gridLines="'Both'"
      :highlightWeekends="true"
      :timelineSettings="timelineSettings"
      :labelSettings="labelSettings"
      :taskbarHeight="20"
      :rowHeight="40"
      :eventMarkers="eventMarkers"
      :height="'550px'"
      :allowUnscheduledTasks="true"
      :projectStartDate="projectStartDate"
      :projectEndDate="projectEndDate"
    />
  </div>
</template>

<script setup>
import { provide, ref } from 'vue';
import { GanttComponent as EjsGantt, Selection, Toolbar, DayMarkers, Edit, Filter, Sort, ContextMenu } from '@syncfusion/ej2-vue-gantt';
import { WBSData } from './data-source.js';

const gantt = ref(null);
provide('gantt', [Selection, Toolbar, DayMarkers, Edit, Filter, Sort, ContextMenu]);

const enableWBS = true;
const enableAutoWbsUpdate = true;
const projectData = WBSData;
const projectStartDate = new Date('03/31/2024');
const projectEndDate = new Date('05/30/2024');

const taskFields = {
  id: 'TaskID',
  name: 'TaskName',
  startDate: 'StartDate',
  duration: 'Duration',
  progress: 'Progress',
  dependency: 'Predecessor',
  parentID: 'ParentId',
};

const columns = [
  { field: 'TaskID', headerText: 'Task ID', visible: false },
  { field: 'WBSCode', headerText: 'WBS Code', width: '150px' },
  { field: 'TaskName', headerText: 'Task Name', allowReordering: false, width: '260px' },
  { field: 'StartDate', headerText: 'Start Date', width: '140px' },
  { field: 'WBSPredecessor', headerText: 'WBS Predecessor', width: '190px' },
  { field: 'Duration', headerText: 'Duration', allowEditing: false, width: '130px' },
  { field: 'Progress', headerText: 'Progress' },
];

const toolbar = ['Add', 'Edit', 'Update', 'Delete', 'Cancel', 'ExpandAll', 'CollapseAll'];

const filterSettings = { type: 'Menu' };
const selectionSettings = { mode: 'Row', type: 'Single', enableToggle: false };
const splitterSettings = { columnIndex: 4 };

const timelineSettings = {
  showTooltip: true,
  topTier: { unit: 'Week', format: 'dd/MM/yyyy' },
  bottomTier: { unit: 'Day', count: 1 },
};

const labelSettings = {
  leftLabel: 'TaskID',
  rightLabel: 'Task Name: ${taskData.TaskName}',
  taskLabel: '${Progress}%',
};

const eventMarkers = [{ day: new Date('04/02/2024'), label: 'Project Initiation' }];
</script>
<template>
  <div class="content-wrapper">
    <ejs-gantt
      id="HierarchyProjectview"
      :dataSource="projectData"
      :taskFields="taskFields"
      :columns="columns"
      :editSettings="editSettings"
      :toolbar="toolbar"
      :allowSorting="true"
      :enableContextMenu="true"
      :enableWBS="enableWBS"
      :treeColumnIndex="2"
      :enableAutoWbsUpdate="enableAutoWbsUpdate"
      :allowFiltering="true"
      :filterSettings="filterSettings"
      :selectionSettings="selectionSettings"
      :splitterSettings="splitterSettings"
      :gridLines="'Both'"
      :highlightWeekends="true"
      :timelineSettings="timelineSettings"
      :labelSettings="labelSettings"
      :taskbarHeight="20"
      :rowHeight="40"
      :eventMarkers="eventMarkers"
      :height="'550px'"
      :allowUnscheduledTasks="true"
      :projectStartDate="projectStartDate"
      :projectEndDate="projectEndDate"
    />
  </div>
</template>

<script>
import { GanttComponent, Selection, Toolbar, DayMarkers, Edit, Filter, Sort, ContextMenu } from '@syncfusion/ej2-vue-gantt';
import { WBSData } from './data-source.js';

export default {
  name: 'App',
  components: {
    'ejs-gantt': GanttComponent,
  },
  data() {
    return {
      enableWBS: true,
      enableAutoWbsUpdate: true,
      projectData: WBSData,
      projectStartDate: new Date('03/31/2024'),
      projectEndDate: new Date('05/30/2024'),
      taskFields: {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        dependency: 'Predecessor',
        parentID: 'ParentId',
      },
      columns: [
        { field: 'TaskID', headerText: 'Task ID', visible: false },
        { field: 'WBSCode', headerText: 'WBS Code', width: '150px' },
        { field: 'TaskName', headerText: 'Task Name', allowReordering: false, width: '260px' },
        { field: 'StartDate', headerText: 'Start Date', width: '140px' },
        { field: 'WBSPredecessor', headerText: 'WBS Predecessor', width: '190px' },
        { field: 'Duration', headerText: 'Duration', allowEditing: false, width: '130px' },
        { field: 'Progress', headerText: 'Progress' },
      ],
      toolbar: ['Add', 'Edit', 'Update', 'Delete', 'Cancel', 'ExpandAll', 'CollapseAll'],
      filterSettings: { type: 'Menu' },
      selectionSettings: { mode: 'Row', type: 'Single', enableToggle: false },
      splitterSettings: { columnIndex: 4 },
      timelineSettings: {
        showTooltip: true,
        topTier: { unit: 'Week', format: 'dd/MM/yyyy' },
        bottomTier: { unit: 'Day', count: 1 },
      },
      labelSettings: {
        leftLabel: 'TaskID',
        rightLabel: 'Task Name: ${taskData.TaskName}',
        taskLabel: '${Progress}%',
      },
      eventMarkers: [{ day: new Date('04/02/2024'), label: 'Project Initiation' }],
    };
  },
  provide: {
    gantt: [Selection, Toolbar, DayMarkers, Edit, Filter, Sort, ContextMenu],
  },
};
</script>

Managing WBS code updates

For better performance, you can control when WBS codes are updated by using the actionBegin and dataBound events. This is particularly useful during actions such as dragging and dropping rows.

In the following example, WBS auto-update is enabled only during the row drag and drop action using these events.

<template>
  <div class="content-wrapper">
    <ejs-gantt
      ref="gantt"
      id="HierarchyProjectview"
      :dataSource="projectData"
      :taskFields="taskFields"
      :columns="columns"
      :editSettings="editSettings"
      :toolbar="toolbar"
      :allowSorting="true"
      :enableContextMenu="true"
      :enableWBS="true"
      :treeColumnIndex="2"
      :enableAutoWbsUpdate="enableAutoWbsUpdate"
      :allowFiltering="true"
      :filterSettings="filterSettings"
      :selectionSettings="selectionSettings"
      :splitterSettings="splitterSettings"
      :gridLines="'Both'"
      :highlightWeekends="true"
      :timelineSettings="timelineSettings"
      :labelSettings="labelSettings"
      :taskbarHeight="20"
      :rowHeight="40"
      :eventMarkers="eventMarkers"
      :height="'550px'"
      :allowUnscheduledTasks="true"
      :projectStartDate="projectStartDate"
      :projectEndDate="projectEndDate"
      @actionBegin="actionBegin"
      @dataBound="dataBound"
    />
  </div>
</template>

<script setup>
import { ref, provide } from 'vue';
import {
  GanttComponent as EjsGantt,
  Selection,
  Toolbar,
  DayMarkers,
  Edit,
  Filter,
  Sort,
  ContextMenu
} from '@syncfusion/ej2-vue-gantt';
import { WBSData } from './data-source.js';

provide('gantt', [Selection, Toolbar, DayMarkers, Edit, Filter, Sort, ContextMenu]);

const gantt = ref(null);
const isRowDropped = ref(false);
const enableAutoWbsUpdate = ref(false);
const projectData = WBSData;

const taskFields = {
  id: 'TaskID',
  name: 'TaskName',
  startDate: 'StartDate',
  duration: 'Duration',
  progress: 'Progress',
  dependency: 'Predecessor',
  parentID: 'ParentId',
};

const columns = [
  { field: 'TaskID', visible: false },
  { field: 'WBSCode', headerText: 'WBS Code', width: '150px' },
  { field: 'TaskName', headerText: 'Task Name', width: '260px' },
  { field: 'StartDate', headerText: 'Start Date', width: '140px' },
  { field: 'WBSPredecessor', headerText: 'WBS Predecessor', width: '190px' },
  { field: 'Duration', headerText: 'Duration', allowEditing: false, width: '130px' },
  { field: 'Progress', headerText: 'Progress' }
];

const editSettings = {
  allowAdding: true,
  allowEditing: true,
  allowDeleting: true,
  allowTaskbarEditing: true,
  showDeleteConfirmDialog: true
};

const toolbar = ['Add', 'Edit', 'Update', 'Delete', 'Cancel', 'ExpandAll', 'CollapseAll'];
const filterSettings = { type: 'Menu' };
const selectionSettings = { mode: 'Row', type: 'Single' };
const splitterSettings = { columnIndex: 4 };
const timelineSettings = {
  topTier: { unit: 'Week', format: 'dd/MM/yyyy' },
  bottomTier: { unit: 'Day', count: 1 },
  showTooltip: true
};

const labelSettings = {
  leftLabel: 'TaskID',
  rightLabel: 'Task Name: ${taskData.TaskName}',
  taskLabel: '${Progress}%'
};

const eventMarkers = [{ day: new Date('04/02/2024'), label: 'Project Initiation' }];
const projectStartDate = new Date('03/31/2024');
const projectEndDate = new Date('05/30/2024');

function actionBegin(args) {
  if (args.requestType === 'beforeDrop') {
    isRowDropped.value = true;
    gantt.value.ej2Instances.enableAutoWbsUpdate = true;
  }
}

function dataBound() {
  if (isRowDropped.value) {
    gantt.value.ej2Instances.enableAutoWbsUpdate = false;
    isRowDropped.value = false;
  }
}
</script>
<template>
  <div class="content-wrapper">
    <ejs-gantt
      ref="gantt"
      id="HierarchyProjectview"
      :dataSource="projectData"
      :taskFields="taskFields"
      :columns="columns"
      :editSettings="editSettings"
      :toolbar="toolbar"
      :allowSorting="true"
      :enableContextMenu="true"
      :enableWBS="true"
      :treeColumnIndex="2"
      :enableAutoWbsUpdate="enableAutoWbsUpdate"
      :allowFiltering="true"
      :filterSettings="filterSettings"
      :selectionSettings="selectionSettings"
      :splitterSettings="splitterSettings"
      :gridLines="'Both'"
      :highlightWeekends="true"
      :timelineSettings="timelineSettings"
      :labelSettings="labelSettings"
      :taskbarHeight="20"
      :rowHeight="40"
      :eventMarkers="eventMarkers"
      :height="'550px'"
      :allowUnscheduledTasks="true"
      :projectStartDate="projectStartDate"
      :projectEndDate="projectEndDate"
      @actionBegin="actionBegin"
      @dataBound="dataBound"
    />
  </div>
</template>

<script>
import {
  GanttComponent,
  Selection,
  Toolbar,
  DayMarkers,
  Edit,
  Filter,
  Sort,
  ContextMenu
} from '@syncfusion/ej2-vue-gantt';
import { WBSData } from './data-source.js';

export default {
  components: {
    'ejs-gantt': GanttComponent
  },
  data() {
    return {
      isRowDropped: false,
      enableAutoWbsUpdate: false,
      projectData: WBSData,
      taskFields: {
        id: 'TaskID',
        name: 'TaskName',
        startDate: 'StartDate',
        duration: 'Duration',
        progress: 'Progress',
        dependency: 'Predecessor',
        parentID: 'ParentId'
      },
      columns: [
        { field: 'TaskID', visible: false },
        { field: 'WBSCode', headerText: 'WBS Code', width: '150px' },
        { field: 'TaskName', headerText: 'Task Name', width: '260px' },
        { field: 'StartDate', headerText: 'Start Date', width: '140px' },
        { field: 'WBSPredecessor', headerText: 'WBS Predecessor', width: '190px' },
        { field: 'Duration', headerText: 'Duration', allowEditing: false, width: '130px' },
        { field: 'Progress', headerText: 'Progress' }
      ],
      editSettings: {
        allowAdding: true,
        allowEditing: true,
        allowDeleting: true,
        allowTaskbarEditing: true,
        showDeleteConfirmDialog: true
      },
      toolbar: ['Add', 'Edit', 'Update', 'Delete', 'Cancel', 'ExpandAll', 'CollapseAll'],
      filterSettings: { type: 'Menu' },
      selectionSettings: { mode: 'Row', type: 'Single' },
      splitterSettings: { columnIndex: 4 },
      timelineSettings: {
        topTier: { unit: 'Week', format: 'dd/MM/yyyy' },
        bottomTier: { unit: 'Day', count: 1 },
        showTooltip: true
      },
      labelSettings: {
        leftLabel: 'TaskID',
        rightLabel: 'Task Name: ${taskData.TaskName}',
        taskLabel: '${Progress}%'
      },
      eventMarkers: [{ day: new Date('04/02/2024'), label: 'Project Initiation' }],
      projectStartDate: new Date('03/31/2024'),
      projectEndDate: new Date('05/30/2024')
    };
  },
  provide: {
    gantt: [Selection, Toolbar, DayMarkers, Edit, Filter, Sort, ContextMenu]
  },
  methods: {
    actionBegin(args) {
      if (args.requestType === 'beforeDrop') {
        this.isRowDropped = true;
        this.$refs.gantt.ej2Instances.enableAutoWbsUpdate = true;
      }
    },
    dataBound() {
      if (this.isRowDropped) {
        this.$refs.gantt.ej2Instances.enableAutoWbsUpdate = false;
        this.isRowDropped = false;
      }
    }
  }
};
</script>

Limitations

The WBS feature has the following limitations in the Vue Gantt Chart component:

  • Editing the WBS code and WBS predecessor columns is not supported.
  • Load on demand is not supported with the WBS feature.
  • WBS Code and WBS Predecessor fields cannot be mapped directly from the data source.